% lr_sp500_summary.m
% August 28, 2014, MWW
% This program carries on long-run prediction Results for Quarterly Data
% ----------- Step 1: Set up parameters and so forth for run
clear all;
small = 1.0e-10;
  % -- File Directories 
  
  outdir = '/Users/mwatson/Dropbox/VIC/Matlab/out/';
  figdir = '/Users/mwatson/Dropbox/VIC/Matlab/fig/';
  matdir = '/Users/mwatson/Dropbox/VIC/Matlab/mat/';;
  mat_save_dir = '/Users/mwatson/Dropbox/VIC/Matlab/mat_save/';;  % Location for Saving Various Files
  
  % -- Parameters
  q = 12;                         % value of q to use 
  clevel_vec = [0.67;0.90];       % Confidence Level
  rho = 0.50;                     % Horizon fraction

  % ---- Series to use and output file
  x_str = 'sp500_ret';
  
  str_out = [outdir x_str '_summary.out'];
  fid_out = fopen(str_out,'w');
  
  str_tmp = [mat_save_dir 'Bayes_save' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'MN_save' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'MLE_save' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'I0_save' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'xbar_os_save' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'X_all' x_str];
  load(str_tmp);
  str_tmp = [mat_save_dir 'calvec' x_str];
  load(str_tmp);
  
  ismpl = isnan(xbar_os_save)==0;
  
  Bayes_save = Bayes_save(ismpl,:);
  MN_save = MN_save(ismpl,:);
  MLE_save = MLE_save(ismpl,:);
  I0_save = I0_save(ismpl,:);
  xbar_os_save = xbar_os_save(ismpl,:);
  X_all = X_all(ismpl,:);
  calvec = calvec(ismpl);
  nobs = size(calvec,1);
  
  fprintf(fid_out,'Number of forecasts =  %7.0f\n',nobs);
  % Compute fraction in for each value of clevel
  for ic = 1:size(clevel_vec);
  	jj = 2*(ic-1);
  	fprintf(fid_out,'\n\n');
  	fprintf(fid_out,' Results for Confidence level: %5.2f\n',clevel_vec(ic));
  	
  	tmp = Bayes_save;
    tmp = tmp(:,jj+1:jj+2);
    tmp1 = mean((tmp(:,1) <= xbar_os_save).*(tmp(:,2) >= xbar_os_save));
    fprintf(fid_out,'    Coverage of Bayes Sets = %6.2f\n',tmp1);
    
    tmp = MN_save;
    tmp = tmp(:,jj+1:jj+2);
    tmp1 = mean((tmp(:,1) <= xbar_os_save).*(tmp(:,2) >= xbar_os_save));
    fprintf(fid_out,'    Coverage of MN Sets = %6.2f\n',tmp1);
    
    tmp = MLE_save;
    tmp = tmp(:,jj+1:jj+2);
    tmp1 = mean((tmp(:,1) <= xbar_os_save).*(tmp(:,2) >= xbar_os_save));
    fprintf(fid_out,'    Coverage of MLE Sets = %6.2f\n',tmp1);
    
    tmp = I0_save;
    tmp = tmp(:,jj+1:jj+2);
    tmp1 = mean((tmp(:,1) <= xbar_os_save).*(tmp(:,2) >= xbar_os_save));
    fprintf(fid_out,'    Coverage of I0 Sets = %6.2f\n',tmp1);
    
    % Compute fraction sets with MN = Bayes
    tmp = Bayes_save(:,jj+1:jj+2) == MN_save(:,jj+1:jj+2);
    tmp1 = sum(tmp') == 2;
    tmp2 = mean(tmp1);
    fprintf(fid_out,'    Fraction of MN sets = Bayes Sets: %6.2f\n',tmp2);
    
    
  end;
  
  
   box on;
   
   plot(calvec,X_all,'- k','LineWidth',0.5);
   save_g_str = [figdir x_str '.png'];
   saveas(gcf,save_g_str);
   
   
   jj = 0;
    plot(calvec,xbar_os_save,'- k','LineWidth',1);
   hold on;
    plot(calvec,Bayes_save(:,jj+1:jj+2),'- r','LineWidth',0.3);
    plot(calvec,MN_save(:,jj+1:jj+2),': r','LineWidth',0.5);
   hold off; 
   save_g_str = [figdir x_str '_67_poos.png'];
   saveas(gcf,save_g_str);
   

   
   box on;
   dif = MN_save(:,jj+1:jj+2)-Bayes_save(:,jj+1:jj+2);
     plot(calvec,dif(:,1),'- k','LineWidth',0.5);
   hold on;
   
    plot(calvec,dif(:,2),'- k','LineWidth',0.5);
   hold off; 
   save_g_str = [figdir x_str '_67_dif_poos.png'];
   saveas(gcf,save_g_str);
   
   
   box on;
   jj = 2;
    plot(calvec,xbar_os_save,'- k','LineWidth',1);
   hold on;
    plot(calvec,Bayes_save(:,jj+1:jj+2),'- r','LineWidth',0.3);
    plot(calvec,MN_save(:,jj+1:jj+2),': r','LineWidth',0.5);
   hold off; 
   save_g_str = [figdir x_str '_90_poos.png'];
   saveas(gcf,save_g_str);
   
  
  type(str_out);
    	
  